From 0435a818428856aa8987cbd8702fbc60a365b9a2 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 11 2020 05:57:33 +0000
Subject: [PATCH 597/2232] Recover from some enum parsing errors


---

diff --git a/syntax/parse.rs b/syntax/parse.rs
index 1525fbc..ab5dcc1 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -111,10 +111,8 @@ fn parse_enum(cx: &mut Errors, item: ItemEnum) -> Result<Api> {
         match variant.fields {
             Fields::Unit => {}
             _ => {
-                return Err(Error::new_spanned(
-                    variant,
-                    "enums with data are not supported yet",
-                ));
+                cx.error(variant, "enums with data are not supported yet");
+                break;
             }
         }
         let expr = variant.discriminant.as_ref().map(|(_, expr)| expr);
@@ -124,7 +122,10 @@ fn parse_enum(cx: &mut Errors, item: ItemEnum) -> Result<Api> {
         };
         let discriminant = match try_discriminant {
             Ok(discriminant) => discriminant,
-            Err(err) => return Err(Error::new_spanned(variant, err)),
+            Err(err) => {
+                cx.error(variant, err);
+                break;
+            }
         };
         let expr = variant.discriminant.map(|(_, expr)| expr);
         variants.push(Variant {
@@ -137,13 +138,15 @@ fn parse_enum(cx: &mut Errors, item: ItemEnum) -> Result<Api> {
     let enum_token = item.enum_token;
     let brace_token = item.brace_token;
 
-    let repr = match discriminants.inferred_repr() {
-        Ok(repr) => repr,
+    let mut repr = U8;
+    match discriminants.inferred_repr() {
+        Ok(inferred) => repr = inferred,
         Err(err) => {
             let span = quote_spanned!(brace_token.span=> #enum_token {});
-            return Err(Error::new_spanned(span, err));
+            cx.error(span, err);
+            variants.clear();
         }
-    };
+    }
 
     Ok(Api::Enum(Enum {
         doc,

